unit PreModule;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button_Choice1: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    Button_Choice2: TButton;
    Label3: TLabel;
    SpinEdit1: TSpinEdit;
    Button_OK: TButton;
    Button_Cancel: TButton;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Button_FilesOut: TButton;
    Label4: TLabel;
    procedure Button_OKClick(Sender: TObject);
    procedure Button_CancelClick(Sender: TObject);
    procedure Button_Choice1Click(Sender: TObject);
    procedure Button_Choice2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button_FilesOutClick(Sender: TObject);
    procedure SpinEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  arAdd: array of byte;

implementation

uses MainModule;

{$R *.dfm}

////////////////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////////////////

procedure ExoticVariant();
//  
var
  str: string;
begin
  if differenceBetweenFiles>0
    then str:=strFileName2
    else str:=strFileName1;
  if MessageDlg(Concat('     ''',ExtractFileName(str),'''    .    ?'),
                mtInformation, mbOKCancel,0)=mrOK
    then DecreaseFile;
end;

function myLoadFiles(): boolean;
//      
//    FALSE
var
  i,j: integer;
begin
  result:=false ;
  strFileName1:=Trim(Form2.Edit1.Text);
  strFileName2:=Trim(Form2.Edit2.Text);
  if (strFileName1='') or (strFileName2='')
    then begin
         ShowMessage(',    ');
         EXIT;
         end;
  strFileName1:=ExpandFileName(strFileName1);
  strFileName2:=ExpandFileName(strFileName2);
  AssignFile(F1,strFileName1);
  AssignFile(F2,strFileName2);

  {$I-}
  Reset(F1,1);
  if IOResult<>0 then begin
                      ShowMessage('    '''+strFileName1+'''.       ');
                      EXIT;
                      end;
  Reset(F2,1);
  if IOResult<>0 then begin
                      ShowMessage('    '''+strFileName2+'''.       ');
                      CloseFile(F1);
                      EXIT;
                      end;
  {$I+}

  i:=FileSize(F1);
  j:=FileSize(F2);
  differenceBetweenFiles:=i-j;
  if differenceBetweenFiles<>0 then
    begin
    if MessageDlg(Concat('     .',#13,
                         strFileName1,' :'#9,IntToStr(i),#13,
                         strFileName2,' :'#9,IntToStr(j),#13#13,
                         '      ,                  [00]. (       .) ?'),
                         mtInformation,mbOKCancel,0)=mrOk
      then begin
            if differenceBetweenFiles>0
             then begin
                  Seek(F2,i);
                  Truncate(F2);
                  Seek(F2,0);
                  end
             else begin
                  Seek(F1,j);
                  Truncate(F1);
                  Seek(F1,0);
                  i:=j;
                  end ;
           end
      else
          begin
          CloseFile(F1);
          CloseFile(F2);
          EXIT;
          end;
    end;
  SetLength(arFile,i);
  SetLength(arAdd,i);
  BlockRead(F1,arFile[0],i);
  BlockRead(F2,arAdd[0],i);

  lengthEachFile:=i;
  myLoadFiles:=true;
end;

////////////////////////////////////////////////////////////////////////////////////////////
//                       
////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm2.Button_CancelClick(Sender: TObject);
begin
  ModalResult:=mrCancel;
end;

procedure TForm2.Button_Choice1Click(Sender: TObject);
begin
  if strFileName1<>''
    then OpenDialog1.InitialDir:=ExtractFileDir(strFileName1);
  if OpenDialog1.Execute then Edit1.Text:=OpenDialog1.FileName;
end;

procedure TForm2.Button_Choice2Click(Sender: TObject);
begin      
  if strFileName2<>''
    then OpenDialog1.InitialDir:=ExtractFileDir(strFileName2);
  if OpenDialog1.Execute then Edit2.Text:=OpenDialog1.FileName;
end;

procedure TForm2.Button_FilesOutClick(Sender: TObject);
//    
begin
  if EndGame
    then begin
         arFile:=nil;
         arInf:=nil;
         upIndex:=-1;
         Panel2.Visible:=false;
         Panel1.Visible:=true;
         Form1.PaintBox1.Height:=1;
         Form1.PaintBox1.Top:=0;
         Form1.ScrollBar1.Visible:=false;
         Form1.Memo1.Text:='';
         Form1.Memo2.Text:='';
         Form1.Label1.Visible:=false;
         Form1.Memo3.Visible:=false;
         Form1.N_TXT.Enabled:=false;
         Form1.N_AllRangesToRight.Enabled:=false;
         Form1.N_AllRangesInvertion.Enabled:=false;
         Form1.N2.Enabled:=false;
         Form1.Button_ShellExecute.Enabled:=false;
         Form1.PaintBox2.Canvas.FillRect(Rect(0,0,Form1.PaintBox2.width,Form1.PaintBox2.Height));
         SpinEdit1.SetFocus;
         end;
end;

procedure TForm2.Button_OKClick(Sender: TObject);
//     (  myLoadFiles)
//          arInf
var
  i,j: integer;   // 
  ic: integer;    //      /     
  bWork: boolean; //    
begin
  if not myLoadFiles then Exit;
  limit:=SpinEdit1.Value;
  bWork:=false;              //upIndex      -1

  for i:=0 to pred(lengthEachFile) do       //   
     if arFile[i]=arAdd[i]
       then begin
            if bWork then begin
                          inc(ic);
                          if ic>limit then begin
                                           bWork:=false;
                                           arInf[upIndex].lngth:=i-arInf[upIndex].bgn-limit;
                                           end;
                          end;
            end
       else begin
            if bWork
              then ic:=0
              else begin
                   inc(upIndex);
                   SetLength(arInf,succ(upIndex));
                   arInf[upIndex].bgn:=i;
                   ic:=0;
                   bWork:=true;
                   end;
            end;

  if bWork then arInf[upIndex].lngth:=i-arInf[upIndex].bgn-ic;

  if upIndex=-1 then begin
                     ShowMessage('     .    ');
                     if differenceBetweenFiles<>0 then ExoticVariant;
                     arFile:=nil;
                     CloseFile(F1);
                     CloseFile(F2);
                     EXIT;
                     end;

  for i:=0 to upIndex do         // ,   
     begin
     j:=arInf[i].bgn;
     if j>=2
       then begin
            move(arFile[j-2],arInf[i].ar1[0],18);
            move(arAdd[j-2],arInf[i].ar2[0],18);
            end
       else begin
            move(arFile[0],arInf[i].ar1[2-j],18);
            move(arAdd[0],arInf[i].ar2[2-j],18);
            end;
     end;

  ic:=0;                       //   
  for i:=0 to upIndex do
     begin
       arInf[i].opt:=ic;
       move(arFile[arInf[i].bgn],arFile[ic],arInf[i].lngth);
       Inc(ic,arInf[i].lngth);
       arInf[i].bool:=false;
     end;

  if arInf[0].bgn<>0 then arInf[0].h1:=42     //  , 
                     else arInf[0].h1:=8;     //   
  for i:=1 to upIndex do
     begin
     arInf[i].h1:=arInf[pred(i)].h1+68;
     end;

  indexSelectedRange:=0;
  ModalResult:=mrOK;
end;

procedure TForm2.SpinEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13 then Button_OKClick(nil)
end;
////////////////////////////////////////////////////////////////////////////////////////////
//                   
////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm2.FormActivate(Sender: TObject);
begin
  Edit1.Text:=strFileName1;
  Edit2.Text:=strFileName2;
  SpinEdit1.Value:=limit;
end;

end.
